<template>
  <div class="app-container">

    <!-- 查询和其他操作 -->
    <div class="filter-container">
      <el-input v-model="listQuery.name" clearable class="filter-item" style="width: 200px;" placeholder="请输入门店" />
      <el-select v-model="listQuery.shopCity" clearable style="width: 200px" class="filter-item" placeholder="请选择所属城市">
        <el-option v-for="type in citys" :key="type.id" :label="type.cityName" :value="type.id" />
      </el-select>
      <el-button v-permission="['GET /admin/shop/list']" class="filter-item" type="primary" icon="el-icon-search" @click="handleFilter">查找</el-button>
      <el-button v-permission="['POST /admin/shop/create']" class="filter-item" type="primary" icon="el-icon-edit" @click="handleCreate">添加</el-button>
      <el-button :loading="downloadLoading" class="filter-item" type="primary" icon="el-icon-download" @click="handleDownload">导出</el-button>
    </div>

    <!-- 查询结果 -->
    <el-table v-loading="listLoading" :data="list" element-loading-text="正在查询中。。。" border fit highlight-current-row>
      <el-table-column align="center" label="门店编号" prop="shopNo" sortable />

      <el-table-column align="center" label="门店名称" prop="shopName" />

      <el-table-column align="center" label="门店渠道" prop="shopChannel">
        <template slot-scope="scope">
          <el-tag type="primary">{{ scope.row.shopChannel | channelsFilter }}</el-tag>
        </template>
      </el-table-column>

      <el-table-column align="center" label="城市" prop="shopCity" />
      <el-table-column align="center" label="状态" prop="deleted">
        <template slot-scope="scope">
          <span v-if="scope.row.deleted == true">已停用</span>
          <span v-else>正常</span>
        </template>
      </el-table-column>

      <el-table-column align="center" label="操作" width="250" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button v-permission="['POST /admin/shop/update']" type="primary" size="mini" @click="handleUpdate(scope.row)">编辑</el-button>
          <el-button v-permission="['POST /admin/shop/delete']" type="danger" size="mini" @click="handleDelete(scope.row)">删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total>0" :total="total" :page.sync="listQuery.page" :limit.sync="listQuery.limit" @pagination="getList" />

    <!-- 添加或修改对话框 -->
    <el-dialog :title="textMap[dialogStatus]" :visible.sync="dialogFormVisible">
      <el-form ref="dataForm" :rules="rules" :model="dataForm" status-icon label-position="left" label-width="100px" style="width: 400px; margin-left:50px;">
        <el-form-item label="门店名称" prop="shopName">
          <el-input v-model="dataForm.shopName" />
        </el-form-item>
        <el-form-item label="门店编号" prop="shopNo">
          <el-input v-model="dataForm.shopNo" />
        </el-form-item>
        <el-form-item label="所属城市" prop="shopCity">
          <el-select v-model="dataForm.shopCity" clearable style="width: 200px" class="filter-item" placeholder="请选择所属城市">
            <el-option v-for="type in citys" :key="type.id" :label="type.cityName" :value="type.id" />
          </el-select>
        </el-form-item>

        <el-form-item label="所属渠道" prop="shopChannel">
          <el-select v-model="dataForm.shopChannel" clearable style="width: 200px" class="filter-item" placeholder="请选择渠道">
            <el-option v-for="type in channels" :key="type.id" :label="type.name" :value="type.id" />
          </el-select>
        </el-form-item>

        <el-form-item label="状态" prop="deleted">
          <el-select v-model="dataForm.deleted" clearable style="width: 200px" class="filter-item" placeholder="请选择状态">
            <el-option v-for="type in deletedOptions" :key="type.value" :label="type.label" :value="type.value" />
          </el-select>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button @click="dialogFormVisible = false">取消</el-button>
        <el-button v-if="dialogStatus=='create'" type="primary" @click="createData">确定</el-button>
        <el-button v-else type="primary" @click="updateData">确定</el-button>
      </div>
    </el-dialog>

  </div>
</template>

<script>
import { listShop, createShop, updateShop, deleteShop } from '@/api/shop'
import { listAllCity } from '@/api/city'
import { allChannel } from '@/api/channel'
import Pagination from '@/components/Pagination' // Secondary package based on el-pagination
let vm

export default {
  name: 'Shop',
  components: { Pagination },
  filters: {
    channelsFilter(value) {
      const rs = vm.channels.filter((item) => {
        return item.id === value
      })

      if (rs != null && rs.length > 0) { return rs[0].name }
    }
  },
  data() {
    return {
      list: null,
      total: 0,
      listLoading: true,
      listQuery: {
        name: undefined,
        shopCity: undefined,
        page: 1,
        limit: 20,
        sort: 'create_time',
        order: 'desc'
      },
      channels: [],
      dataForm: {
        id: undefined,
        shopId: '',
        shopName: '',
        deleted: false,
        shopCity: undefined,
        shopChannel: undefined
      },
      citys: [],
      deletedOptions: [{
        value: false,
        label: '正常'
      }, {
        value: true,
        label: '删除'
      }],
      dialogFormVisible: false,
      dialogStatus: '',
      textMap: {
        update: '编辑',
        create: '创建'
      },
      rules: {
        shopNo: [{ required: true, message: '编号不能为空', trigger: 'blur' }],
        shopName: [{ required: true, message: '名称不能为空', trigger: 'blur' }],
        shopCity: [{ required: true, message: '城市不能为空', trigger: 'blur' }],
        channelId: [{ required: true, message: '渠道不能为空', trigger: 'blur' }]
      },
      downloadLoading: false
    }
  },
  beforeCreate() {
    vm = this
  },
  created() {
    this.getList()
    allChannel().then(res => {
      this.channels = res.data.data
    })
    listAllCity().then(res => {
      console.info(res.data.data)
      this.citys = res.data.data
    })
  },
  methods: {
    getList() {
      this.listLoading = true
      listShop(this.listQuery).then(response => {
        this.list = response.data.data.list
        this.total = response.data.data.total
        this.listLoading = false
      }).catch(() => {
        this.list = []
        this.total = 0
        this.listLoading = false
      })
    },
    handleFilter() {
      this.listQuery.page = 1
      this.getList()
    },
    resetForm() {
      this.dataForm = {
        id: undefined,
        shopId: '',
        shopName: ''
      }
    },
    handleCreate() {
      this.resetForm()
      this.dialogStatus = 'create'
      this.dialogFormVisible = true
      this.$nextTick(() => {
        this.$refs['dataForm'].clearValidate()
      })
    },
    createData() {
      this.$refs['dataForm'].validate((valid) => {
        if (valid) {
          createShop(this.dataForm).then(response => {
            this.list.unshift(response.data.data)
            this.dialogFormVisible = false
            this.$notify.success({
              title: '成功',
              message: '创建成功'
            })
          }).catch(response => {
            this.$notify.error({
              title: '失败',
              message: response.data.errmsg
            })
          })
        }
      })
    },
    handleUpdate(row) {
      this.dataForm = Object.assign({}, row)
      this.dialogStatus = 'update'
      this.dialogFormVisible = true
      this.$nextTick(() => {
        this.$refs['dataForm'].clearValidate()
      })
    },
    updateData() {
      this.$refs['dataForm'].validate((valid) => {
        if (valid) {
          updateShop(this.dataForm).then(() => {
            for (const v of this.list) {
              if (v.id === this.dataForm.id) {
                const index = this.list.indexOf(v)
                this.list.splice(index, 1, this.dataForm)
                break
              }
            }
            this.dialogFormVisible = false
            this.$notify.success({
              title: '成功',
              message: '更新成功'
            })
          }).catch(response => {
            this.$notify.error({
              title: '失败',
              message: response.data.errmsg
            })
          })
        }
      })
    },
    handleDelete(row) {
      deleteShop(row).then(response => {
        this.$notify.success({
          title: '成功',
          message: '删除成功'
        })
        const index = this.list.indexOf(row)
        this.list.splice(index, 1)
      }).catch(response => {
        this.$notify.error({
          title: '失败',
          message: response.data.errmsg
        })
      })
    },
    handleDownload() {
      this.downloadLoading = true
      import('@/vendor/Export2Excel').then(excel => {
        const tHeader = ['问题ID', '问题内容', '问题回复']
        const filterVal = ['id', 'question', 'answer']
        excel.export_json_to_excel2(tHeader, this.list, filterVal, '常见问题信息')
        this.downloadLoading = false
      })
    }
  }
}
</script>
